typedef struct {
  char name[16];
  int  start;
  int  end;
  int  react;       
} TyAnimation;

typedef enum {
    A_OFF,
    A_ON,
    A_DISSOLVE,
    A_RESOLVE
} EnAnimation;

typedef struct {
    EnAnimation state;
    RwReal      opacity;      
    int         current_frame;
    TyAnimation *current_animation;
    TyAnimation *next_animation;     
    int         animations;
    TyAnimation *animation;        
} TyAnimationData;

typedef struct {
    int         frames;
    RwMatrix4d  **frame;
} TyFrameData;

int LoadAnimation(RwClump *clump, char *filename);
void AnimateScene(void);
RwClump *AnimateClump(RwClump *clump);
void DefineAnimation(RwClump *clump, char *name, int start, int end, int react);
void StartAnimation(RwClump *clump, char *name);
void SetAnimationState(RwClump *clump, EnAnimation state);
EnAnimation GetAnimationState(RwClump *clump);

