#ifdef DEFINE_GLOBAL
#define ref
#define preset(x) = x
#else
#define ref extern
#define preset(x) /* x */
#endif

typedef enum {
    CAM_MAIN,
    CAM_KNIGHT1,
    CAM_KNIGHT2,
    CAM_FLY1,
    CAM_FLY2
} EnCameraState;

#define CAMERA_DISTANCE CREAL(-2.2)

ref RwCamera *Camera preset(NULL);
ref RwCamera *MainCamera preset(NULL);
ref RwCamera *FlyCamera preset(NULL);
ref RwScene *Scene preset(NULL);
ref RwLight *Light preset(NULL);
ref EnCameraState CameraState preset(CAM_MAIN);
ref int InterActive preset(FALSE);
ref RwClump *Knight1 preset(NULL);
ref RwClump *Knight2 preset(NULL);

RwClump *LoadClump(char *filename);
RwRaster *LoadBackdrop(char *filename);
void SetCameraState(EnCameraState state);
void AnimateCamera(void);

int LoadKnight(RwScene *scene);
void ReactKnight(RwClump *clump, TyAnimation *a);
char *RandomKnight(RwClump *clump);
void SetBackdrop(RwCamera *c);
void AnimateKnight(int knight, char *name);
void RenderKnight(void);

#define GetRandInt(minval, maxval) (minval + (16383 + rand()*(maxval - minval))>>15)
