/******************************************/
/*                                        */
/*    RenderWare(TM) Graphics Library     */
/*                                        */
/******************************************/

/*
 * This file is a product of Criterion Software Ltd.
 * 
 * This file is provided as is with no warranties of any kind and is 
 * provided without any obligiation on Criterion Software Ltd.
 * or Canon Inc. to assist in its use or modifiation.
 * 
 * Criterion Software Ltd. and Canon Inc. will not, under any
 * circumstances, be liable for any lost revenue or other damages
 * arising from the use of this file.
 *
 * Copyright (c) 1991, 1992, 1993, 1994. Canon Inc.
 * All Rights Reserved.
 */

#ifndef   _RWLIBH
#define   _RWLIBH

#ifndef    ARGS
#define    ARGS(ALIST)     ALIST
#endif  /* ARGS */

#include <stdio.h>

#ifdef    __cplusplus
extern "C" {
#endif /* __cplusplus */

#include "rwmacros.h"
#include "rwtypes.h"

#ifndef _MODELH
#include "rwerrors.h"
#endif

extern RwClump *            RwAddChildToClump ARGS((RwClump *clump,
                                   RwClump *child));
extern RwScene *            RwAddClumpToScene ARGS((RwScene *scene,
                                   RwClump *clump));
extern RwBool               RwAddHint ARGS((RwClumpHints hint));
extern RwClump *            RwAddHintToClump ARGS((RwClump *clump,
                                   RwClumpHints hint));
extern RwScene *            RwAddLightToScene ARGS((RwScene *scene,
                                   RwLight *light));
extern RwPolygon3d *        RwAddPolygonToClump ARGS((RwClump *clump,
                                   RwInt32 sides,
                                   RwInt32 *varray));
extern RwClump *            RwAddPolygonsToClump ARGS((RwClump *dst,
                                   RwClump *src));
extern RwMaterial *         RwAddTextureModeToMaterial ARGS((RwMaterial *m,
                                   RwTextureModes mode));
extern RwPolygon3d *        RwAddTextureModeToPolygon ARGS((RwPolygon3d *pol,
                                   RwTextureModes mode));
extern RwBool               RwAddTextureModeToSurface ARGS((RwTextureModes mode));
extern RwClump *            RwAddUserDrawToClump ARGS((RwClump *clump,
                                   RwUserDraw * userdraw));
extern RwV3d *              RwAddVector ARGS((RwV3d *a, RwV3d *b, RwV3d *c));
extern RwInt32              RwAddVertexToClump ARGS((RwClump *clump ,
                                   RwReal x, RwReal y, RwReal z));
extern RwCamera *           RwBeginCameraUpdate ARGS((RwCamera *cam, void *param));
extern RwRaster *           RwBitmapRaster ARGS((void *bitmap,
                                   RwRasterOptions options));
extern RwBool               RwBlock ARGS((RwReal width,  RwReal height,
                                   RwReal depth));
extern RwClump *            RwCalculateClumpVertexNormal ARGS((RwClump *clump,
                                   RwInt32 vindex));
extern RwCamera *           RwClearCameraViewport ARGS((RwCamera *cam));
extern void                 RwClose ARGS((void));
extern void                 RwCloseDebugStream ARGS((void));
extern RwBool               RwClumpBegin ARGS((void));
extern RwReal               RwClumpDistance ARGS((RwClump *clump, RwV3d *pos));
extern RwClump *            RwClumpEnd ARGS((RwClump* * instance));
extern RwBool               RwCone ARGS((RwReal height,
                                   RwReal radius, RwInt32 sides));
extern RwMaterial *         RwCopyMaterial ARGS((RwMaterial *src,
                                   RwMaterial *dst));
extern RwMatrix4d *         RwCopyMatrix ARGS((RwMatrix4d *src,
                                   RwMatrix4d *dst));
extern RwCamera *           RwCreateCamera ARGS((RwInt32 maxw, RwInt32 maxh,
                                   void *image));
extern RwClump *            RwCreateClump ARGS((RwInt32 vcount, RwInt32 pcount));
extern RwLight *            RwCreateLight ARGS((RwLightType kind,
                                   RwReal x, RwReal y, RwReal z,
                                   RwReal lum));
extern RwMaterial *         RwCreateMaterial ARGS((void));
extern RwMatrix4d *         RwCreateMatrix ARGS((void));
extern RwRaster *           RwCreateRaster ARGS((RwInt32 w, RwInt32 h));
extern RwScene *            RwCreateScene ARGS((void));
extern RwSpline *           RwCreateSpline ARGS((RwInt32 npoints,
                                   RwSplineType type, RwV3d *pts));
extern RwClump *            RwCreateSprite ARGS((RwTexture *texture));
extern RwTexture *          RwCreateTexture ARGS((RwRaster *raster));
extern RwUserDraw *         RwCreateUserDraw ARGS((RwUserDrawType type,
                                   RwUserDrawAlignmentTypes align,
                                   RwInt32 x, RwInt32 y, RwInt32 width, RwInt32 height,
                                   RwUserDrawCallBack callback));
extern RwV3d *              RwCrossProduct ARGS((RwV3d *a,
                                   RwV3d *b, RwV3d *c));
extern RwClump *            RwCubicTexturizeClump ARGS((RwClump *clump));
extern RwMaterial *         RwCurrentMaterial ARGS((void));
extern RwBool               RwCylinder ARGS((RwReal height,
                                   RwReal minrad, RwReal maxrad, RwInt32 sides));
extern RwCamera *           RwDamageCameraViewport ARGS((RwCamera *cam,
                                   RwInt32 x, RwInt32 y, RwInt32 w, RwInt32 h));
extern RwScene *            RwDefaultScene ARGS((void));
extern RwBool               RwDestroyCamera ARGS((RwCamera *cam));
extern RwBool               RwDestroyClump ARGS((RwClump *clump));
extern RwBool               RwDestroyLight ARGS((RwLight *light));
extern RwBool               RwDestroyMaterial ARGS((RwMaterial *m));
extern RwBool               RwDestroyMatrix ARGS((RwMatrix4d *mat));
extern RwBool               RwDestroyPolygon ARGS((RwPolygon3d *pol));
extern RwBool               RwDestroyRaster ARGS((RwRaster *ras));
extern RwBool               RwDestroyScene ARGS((RwScene *scene));
extern RwBool               RwDestroySpline ARGS((RwSpline *spline));
extern RwBool               RwDestroyTexture ARGS((RwTexture *t));
extern RwBool               RwDestroyUserDraw ARGS((RwUserDraw * userdraw));
extern RwInt32              RwDeviceControl ARGS((RwDeviceAction action,
                                   RwInt32 param1, void *param2, RwInt32 size));
extern RwBool               RwDisc ARGS((RwReal height, RwReal radius,
                                   RwInt32 sides));
extern RwReal               RwDotProduct ARGS((RwV3d *a, RwV3d *b));
extern RwCamera *           RwDuplicateCamera ARGS((RwCamera *cam,
                                   void *image));
extern RwClump *            RwDuplicateClump ARGS((RwClump *clump));
extern RwLight *            RwDuplicateLight ARGS((RwLight *light));
extern RwMaterial *         RwDuplicateMaterial ARGS((RwMaterial *src));
extern RwMatrix4d *         RwDuplicateMatrix ARGS((RwMatrix4d *mat));
extern RwRaster *           RwDuplicateRaster ARGS((RwRaster *ras));
extern RwSpline *           RwDuplicateSpline ARGS((RwSpline *spline));
extern RwUserDraw *         RwDuplicateUserDraw ARGS((RwUserDraw * userdraw));
extern RwCamera *           RwEndCameraUpdate ARGS((RwCamera *cam));
extern RwClump *            RwEnvMapClump ARGS((RwClump *clump));
extern RwClump *            RwFindClump ARGS((RwClump *clump,
                                   RwBool (*predicate) (RwClump *clump)));
extern RwClump *            RwFindClumpInt ARGS((RwClump *clump,
                                   RwBool (*predicate) (RwClump *clump, RwInt32 arg),
                                   RwInt32 arg));
extern RwClump *            RwFindClumpLong ARGS((RwClump *clump,
                                   RwBool (*predicate) (RwClump *clump, RwInt32 arg),
                                   RwInt32 arg));
extern RwClump *            RwFindClumpPointer ARGS((RwClump *clump,
                                   RwBool (*predicate) (RwClump *clump, void *arg),
                                   void *arg));
extern RwClump *            RwFindClumpReal ARGS((RwClump *clump,
                                   RwBool (*predicate) (RwClump *clump, RwReal arg),
                                   RwReal arg));
extern RwTexture *          RwFindNamedTexture ARGS((char *name));
extern RwClump *            RwFindTaggedClump ARGS((RwClump *clump, RwInt32 tag));
extern RwPolygon3d *        RwFindTaggedPolygon ARGS((RwClump *clump,
						      RwInt32 data));
extern RwClump *            RwForAllClumpsInHierarchy ARGS((RwClump *clump,
                                   RwClumpFuncVoid func));
extern RwClump *            RwForAllClumpsInHierarchyInt ARGS((RwClump *clump,
                                   RwClumpFuncInt func, RwInt32 arg));
extern RwClump *            RwForAllClumpsInHierarchyLong ARGS((RwClump *clump,
                                   RwClumpFuncLong func, RwInt32 arg));
extern RwClump *            RwForAllClumpsInHierarchyPointer ARGS((RwClump *clump,
                                   RwClumpFuncPointer func, void *arg));
extern RwClump *            RwForAllClumpsInHierarchyReal ARGS((RwClump *clump,
                                   RwClumpFuncReal func, RwReal arg));
extern RwScene *            RwForAllClumpsInScene ARGS((RwScene *scene,
                                   RwClumpFuncVoid func));
extern RwScene *            RwForAllClumpsInSceneInt ARGS((RwScene *scene,
                                   RwClumpFuncInt func, RwInt32 arg));
extern RwScene *            RwForAllClumpsInSceneLong ARGS((RwScene *scene,
                                   RwClumpFuncLong func, RwInt32 arg));
extern RwScene *            RwForAllClumpsInScenePointer ARGS((RwScene *scene,
                                   RwClumpFuncPointer func, void *arg));
extern RwScene *            RwForAllClumpsInSceneReal ARGS((RwScene *scene,
                                   RwClumpFuncReal func, RwReal arg));
extern RwScene *            RwForAllLightsInScene ARGS((RwScene *scene,
                                   RwLightFuncVoid func));
extern RwScene *            RwForAllLightsInSceneInt ARGS((RwScene *scene,
                                   RwLightFuncInt func, RwInt32 arg));
extern RwScene *            RwForAllLightsInSceneLong ARGS((RwScene *scene,
                                   RwLightFuncLong func, RwInt32 arg));
extern RwScene *            RwForAllLightsInScenePointer ARGS((RwScene *scene,
                                   RwLightFuncPointer func, void *arg));
extern RwScene *            RwForAllLightsInSceneReal ARGS((RwScene *scene,
                                   RwLightFuncReal func, RwReal arg));
extern RwBool               RwForAllNamedTextures ARGS((RwTextureFuncVoid func));
extern RwBool               RwForAllNamedTexturesInt ARGS((RwTextureFuncInt func,
                                   RwInt32 arg));
extern RwBool               RwForAllNamedTexturesLong ARGS((RwTextureFuncLong func,
                                   RwInt32 arg));
extern RwBool               RwForAllNamedTexturesPointer ARGS((RwTextureFuncPointer func,
                                   void *arg));
extern RwBool               RwForAllNamedTexturesReal ARGS((RwTextureFuncReal func,
                                   RwReal arg));
extern RwClump *            RwForAllPolygonsInClump ARGS((RwClump *clump,
                                   RwPolygon3dFuncVoid func));
extern RwClump *            RwForAllPolygonsInClumpInt ARGS((RwClump *clump,
                                   RwPolygon3dFuncInt func, RwInt32 arg));
extern RwClump *            RwForAllPolygonsInClumpLong ARGS((RwClump *clump,
                                   RwPolygon3dFuncLong func, RwInt32 arg));
extern RwClump *            RwForAllPolygonsInClumpPointer ARGS((RwClump *clump,
                                   RwPolygon3dFuncPointer func, void *arg));
extern RwClump *            RwForAllPolygonsInClumpReal ARGS((RwClump *clump,
                                   RwPolygon3dFuncReal func, RwReal arg));
extern RwClump *            RwForAllUserDrawsInClump ARGS((RwClump *clump,
                                   RwUserDrawFuncVoid func));
extern RwClump *            RwForAllUserDrawsInClumpInt ARGS((RwClump *clump,
                                   RwUserDrawFuncInt func, RwInt32 arg));
extern RwClump *            RwForAllUserDrawsInClumpLong ARGS((RwClump *clump,
                                   RwUserDrawFuncLong func, RwInt32 arg));
extern RwClump *            RwForAllUserDrawsInClumpPointer ARGS((RwClump *clump,
                                   RwUserDrawFuncPointer func, void *arg));
extern RwClump *            RwForAllUserDrawsInClumpReal ARGS((RwClump *clump,
                                   RwUserDrawFuncReal func,RwReal arg));
extern RwRGBColor *         RwGetCameraBackColor ARGS((RwCamera *cam,
                                   RwRGBColor *color));
extern RwRaster *           RwGetCameraBackdrop ARGS((RwCamera *cam));
extern RwCamera *           RwGetCameraBackdropOffset ARGS((RwCamera *cam,
                                   RwInt32 *x, RwInt32 *y));
extern RwCamera *           RwGetCameraBackdropViewportRect ARGS((RwCamera *cam,
                                   RwInt32 *x, RwInt32 *y, RwInt32 *w, RwInt32 *h));
extern void *               RwGetCameraData ARGS((RwCamera *cam));
extern void *               RwGetCameraImage ARGS((RwCamera *cam));
extern RwV3d *              RwGetCameraLookAt ARGS((RwCamera *cam, RwV3d *p));
extern RwV3d *              RwGetCameraLookRight ARGS((RwCamera *cam,
                                   RwV3d *p));
extern RwV3d *              RwGetCameraLookUp ARGS((RwCamera *cam,  RwV3d *p));
extern RwReal               RwGetCameraNearClipping ARGS((RwCamera *cam));
extern RwReal               RwGetCameraFarClipping ARGS((RwCamera *cam));
extern RwV3d *              RwGetCameraPosition ARGS((RwCamera *cam,
                                   RwV3d *p));
extern RwCameraProjection   RwGetCameraProjection ARGS((RwCamera *cam));
extern RwV3d *              RwGetCameraViewOffset ARGS((RwCamera *cam,
                                   RwV3d *p));
extern RwCamera *           RwGetCameraViewport ARGS((RwCamera *cam,
                                   RwInt32 *x, RwInt32 *y, RwInt32 *w, RwInt32 *h));
extern RwRaster *           RwGetCameraViewportRaster ARGS((RwCamera *cam,
                                   RwRaster *ras));
extern RwCamera *           RwGetCameraViewwindow ARGS((RwCamera *cam,
                                   RwReal *w, RwReal *h));
extern RwClump *            RwGetClumpBBox ARGS((RwClump *clump,
                                   RwV3d *blleft, RwV3d *furight));
extern void *               RwGetClumpData ARGS((RwClump *clump));
extern RwAxisAlignment      RwGetClumpAxisAlignment ARGS((RwClump *clump));
extern RwClumpHints         RwGetClumpHints ARGS((RwClump *clump));
extern RwMatrix4d *         RwGetClumpJointMatrix ARGS((RwClump *clump,
                                   RwMatrix4d *mat));
extern RwClump *            RwGetClumpLocalBBox ARGS((RwClump *clump,
                                   RwV3d *blleft, RwV3d *furight));
extern RwMatrix4d *         RwGetClumpLTM ARGS((RwClump *clump,
                                   RwMatrix4d *mat));
extern RwMatrix4d *         RwGetClumpMatrix ARGS((RwClump *clump,
                                   RwMatrix4d *mat));
extern RwInt32              RwGetClumpNumChildren ARGS((RwClump *clump));
extern RwInt32              RwGetClumpNumPolygons ARGS((RwClump *clump));
extern RwInt32              RwGetClumpNumUserDraws ARGS((RwClump *clump));
extern RwInt32              RwGetClumpNumVertices ARGS((RwClump *clump));
extern RwV3d *              RwGetClumpOrigin ARGS((RwClump *, RwV3d *origin));
extern RwScene *            RwGetClumpOwner ARGS((RwClump *clump));
extern RwClump *            RwGetClumpParent ARGS((RwClump *clump));
extern RwClump *            RwGetClumpRoot ARGS((RwClump *clump));
extern RwState              RwGetClumpState ARGS((RwClump *clump));
extern RwInt32              RwGetClumpTag ARGS((RwClump *clump));
extern RwV3d *              RwGetClumpVertex ARGS((RwClump *clump,
                                   RwInt32 index, RwV3d *vertex));
extern RwV3d *              RwGetClumpVertexNormal ARGS((RwClump *clump,
                                   RwInt32 index, RwV3d *normal));
extern RwUV *               RwGetClumpVertexUV ARGS((RwClump *clump,
                                   RwInt32 index, RwUV *uv));
extern RwBool               RwGetClumpVertexViewportPosition ARGS((RwClump *clump,
                                   RwInt32 vindex, RwCamera *camera,
                                   RwInt32 *px, RwInt32 *py, RwBool *visible));
extern RwClump *            RwGetClumpViewportRect ARGS((RwClump *clump,
                                   RwCamera *cam, 
                                   RwInt32 *x, RwInt32 *y, RwInt32 *w, RwInt32 *h));
extern RwState         RwGetDebugAssertionState ARGS((void));
extern RwState         RwGetDebugMessageState ARGS((void));
extern RwState         RwGetDebugScriptState ARGS((void));
extern RwDebugSeverity      RwGetDebugSeverity ARGS((void));
extern RwState         RwGetDebugTraceState ARGS((void));
extern RwBool               RwGetDeviceInfo ARGS((RwDeviceInfo info,
                                   void *value, RwInt32 size));
extern RwClump *            RwGetFirstChildClump ARGS((RwClump *clump));
extern RwReal               RwGetLightBrightness ARGS((RwLight *light));
extern RwRGBColor *         RwGetLightColor ARGS((RwLight *light, RwRGBColor *color));
extern RwReal               RwGetLightConeAngle ARGS((RwLight *light));
extern void *               RwGetLightData ARGS((RwLight *light));
extern RwScene *            RwGetLightOwner ARGS((RwLight *light));
extern RwV3d *              RwGetLightPosition ARGS((RwLight *light, RwV3d *p));
extern RwState              RwGetLightState ARGS((RwLight *light));
extern RwLightType          RwGetLightType ARGS((RwLight *light));
extern RwV3d *              RwGetLightVector ARGS((RwLight *light, RwV3d *v));
extern RwReal               RwGetMaterialAmbient ARGS((RwMaterial *m));
extern RwRGBColor *         RwGetMaterialColor ARGS((RwMaterial *m,
                                   RwRGBColor *color));
extern void *               RwGetMaterialData ARGS((RwMaterial *m));
extern RwReal               RwGetMaterialDiffuse ARGS((RwMaterial *m));
extern RwGeometrySampling   RwGetMaterialGeometrySampling ARGS((RwMaterial *m));
extern RwLightSampling      RwGetMaterialLightSampling ARGS((RwMaterial *m));
extern RwReal               RwGetMaterialOpacity ARGS((RwMaterial *m));
extern RwReal               RwGetMaterialSpecular ARGS((RwMaterial *m));
extern RwTexture *          RwGetMaterialTexture ARGS((RwMaterial *m));
extern RwTextureModes       RwGetMaterialTextureModes ARGS((RwMaterial *m));
extern RwReal               RwGetMatrixElement ARGS((RwMatrix4d *mat,
                                   RwInt32 i, RwInt32 j));
extern RwReal *             RwGetMatrixElements ARGS((RwMatrix4d *mat,
                                   RwReal farray[4][4]));
extern RwTexture *          RwGetNamedTexture ARGS((char *name));
extern RwClump *            RwGetNextClump ARGS((RwClump *clump));
extern RwInt32              RwGetNumNamedTextures ARGS((void));
extern RwPaletteEntry       *RwGetPaletteEntries ARGS((RwInt32 n, RwInt32 length, RwPaletteEntry *rgb));
extern RwReal               RwGetPolygonAmbient ARGS((RwPolygon3d *pol));
extern RwV3d *              RwGetPolygonCenter ARGS((RwPolygon3d *pol,
                                   RwV3d *p));
extern RwRGBColor *         RwGetPolygonColor ARGS((RwPolygon3d *pol,
                                   RwRGBColor *color));
extern void *               RwGetPolygonData ARGS((RwPolygon3d *pol));
extern RwReal               RwGetPolygonDiffuse ARGS((RwPolygon3d *pol));
extern RwGeometrySampling   RwGetPolygonGeometrySampling ARGS((RwPolygon3d *p));
extern RwLightSampling      RwGetPolygonLightSampling ARGS((RwPolygon3d *apol));
extern RwMaterial *         RwGetPolygonMaterial ARGS((RwPolygon3d *p));
extern RwV3d *              RwGetPolygonNormal ARGS((RwPolygon3d *pol, 
                                    RwV3d *normal));
extern RwInt32              RwGetPolygonNumSides ARGS((RwPolygon3d *p));
extern RwReal               RwGetPolygonOpacity ARGS((RwPolygon3d *p));
extern RwClump *            RwGetPolygonOwner ARGS((RwPolygon3d *pol));
extern RwReal               RwGetPolygonSpecular ARGS((RwPolygon3d *pol));
extern RwInt32        	    RwGetPolygonTag ARGS((RwPolygon3d *pol));
extern RwTexture *          RwGetPolygonTexture ARGS((RwPolygon3d *p));
extern RwTextureModes       RwGetPolygonTextureModes ARGS((RwPolygon3d *p));
extern RwUV *               RwGetPolygonUV ARGS((RwPolygon3d *p, RwUV *uvs));
extern RwInt32              RwGetPolygonVertices ARGS((RwPolygon3d *p,
                                   RwInt32 *varray));
extern void *               RwGetRasterData ARGS((RwRaster *ras));
extern RwInt32              RwGetRasterDepth ARGS((RwRaster *ras));
extern RwInt32              RwGetRasterHeight ARGS((RwRaster *ras));
extern unsigned char *      RwGetRasterPixels ARGS((RwRaster *ras));
extern RwInt32              RwGetRasterStride ARGS((RwRaster *ras));
extern RwInt32              RwGetRasterWidth ARGS((RwRaster *ras));
extern void *               RwGetSceneData ARGS((RwScene *scene));
extern RwInt32              RwGetSceneNumClumps ARGS((RwScene *scene));
extern RwInt32              RwGetSceneNumLights ARGS((RwScene *scene));
extern char *               RwGetShapePath ARGS((char *path));
extern void *               RwGetSplineData ARGS((RwSpline *spline));
extern RwInt32              RwGetSplineNumPoints ARGS((RwSpline *sp));
extern RwV3d *              RwGetSplinePoint ARGS((RwSpline *sp, RwInt32 index,
                                   RwV3d *point));
extern RwBool               RwGetSystemInfo ARGS((RwSystemInfo type,
                                   void *info, RwInt32 size));
extern void *               RwGetTextureData ARGS((RwTexture *texture));
extern RwSearchMode         RwGetTextureDictSearchMode ARGS((void));
extern RwTextureDitherMode  RwGetTextureDithering ARGS((void));
extern RwInt32              RwGetTextureFrame ARGS((RwTexture *t));
extern RwInt32              RwGetTextureFrameStep ARGS((RwTexture *t));
extern RwState              RwGetTextureGammaCorrection ARGS((void));
extern char *               RwGetTextureName ARGS((RwTexture *texture, char *name,
                                                   RwInt32 size));
extern RwInt32              RwGetTextureNumFrames ARGS((RwTexture *t));
extern RwRaster *           RwGetTextureRaster ARGS((RwTexture *texture));
extern RwUserDrawAlignmentTypes RwGetUserDrawAlignment ARGS((RwUserDraw * userdraw));
extern RwUserDrawCallBack   RwGetUserDrawCallback ARGS((RwUserDraw * userdraw));
extern void *               RwGetUserDrawData ARGS((RwUserDraw * userdraw));
extern RwUserDraw *         RwGetUserDrawOffset ARGS((RwUserDraw * userdraw,
                                   RwInt32 *x, RwInt32 *y));
extern RwClump *            RwGetUserDrawOwner ARGS((RwUserDraw * userdraw));
extern RwUserDrawAlignmentTypes RwGetUserDrawParentAlignment ARGS((RwUserDraw * userdraw));
extern RwUserDraw *         RwGetUserDrawSize ARGS((RwUserDraw * userdraw,
                                   RwInt32 *width, RwInt32 *height));
extern RwUserDrawType       RwGetUserDrawType ARGS((RwUserDraw * userdraw));
extern RwInt32              RwGetUserDrawVertexIndex ARGS((RwUserDraw * userdraw));
extern RwBool               RwHemisphere ARGS((RwReal radius, RwInt32 sides));
extern RwBool               RwIdentityCTM ARGS((void));
extern RwBool               RwIdentityJointTM ARGS((void));
extern RwMatrix4d *         RwIdentityMatrix ARGS((RwMatrix4d *mat));
extern RwBool               RwInclude ARGS((RwClump *clump));
extern RwBool               RwIncludeGeometry ARGS((RwClump *clump));
extern RwCamera *           RwInvalidateCameraViewport ARGS((RwCamera *cam));
extern RwMatrix4d *         RwInvertMatrix ARGS((RwMatrix4d *src,
                                   RwMatrix4d *dst));
extern RwBool               RwJointTransformBegin ARGS((void));
extern RwBool               RwJointTransformEnd ARGS((void));
extern RwTexture *          RwMaskTexture ARGS((RwTexture *texture,
                                   RwRaster *mask));
extern RwBool               RwMaterialBegin ARGS((void));
extern RwBool               RwMaterialEnd ARGS((void));
extern RwBool               RwModelBegin ARGS((void));
extern RwBool               RwModelEnd ARGS((void));
extern RwMatrix4d *         RwMultiplyMatrix ARGS((RwMatrix4d *a,
                                   RwMatrix4d *b, RwMatrix4d *c));
extern RwV3d *              RwNormalize ARGS((RwV3d *p));
extern RwClump *            RwNormalizeClump ARGS((RwClump *clump));
extern RwBool               RwOpen ARGS((char *devname, void *param));
extern RwBool               RwOpenDebugStream ARGS((char *filename));
extern RwBool               RwOpenExt ARGS((char *devname, void *param,
                                   RwInt32 numargs, RwOpenArgument * args));
extern RwMatrix4d *         RwOrthoNormalizeMatrix ARGS((RwMatrix4d *src,
                                   RwMatrix4d *dst));
extern RwCamera *           RwPanCamera ARGS((RwCamera *cam, RwReal theta));
extern RwPickRecord *       RwPickClump ARGS((RwClump *clump,
                                   RwInt32 vpx, RwInt32 vpy,
                                   RwCamera *cam, RwPickRecord *record));
extern RwPickRecord *       RwPickScene ARGS((RwScene *scene,
                                   RwInt32 x, RwInt32 y,
                                   RwCamera *camera, RwPickRecord *record));
extern RwCamera *           RwPointCamera ARGS((RwCamera *cam,
                                   RwReal x, RwReal y, RwReal z));
extern RwBool               RwPolygon ARGS((RwInt32 sides, RwInt32 *varray));
extern RwBool               RwPolygonExt ARGS((RwInt32 sides, RwInt32 *varray,
                                   RwInt32 tag));
extern RwMaterial *         RwPopCurrentMaterial ARGS((void));
extern RwMatrix4d *         RwPopScratchMatrix ARGS((void));
extern RwBool               RwProtoBegin ARGS((char *name));
extern RwBool               RwProtoEnd ARGS((void));
extern RwBool               RwProtoInstance ARGS((char *name));
extern RwBool               RwProtoInstanceGeometry ARGS((char *name));
extern RwMaterial *         RwPushCurrentMaterial ARGS((void));
extern RwMatrix4d *         RwPushScratchMatrix ARGS((void));
extern RwBool               RwQuad ARGS((RwInt32 v1, RwInt32 v2,
                                   RwInt32 v3, RwInt32 v4));
extern RwBool               RwQuadExt ARGS((RwInt32 v1, RwInt32 v2,
                                   RwInt32 v3, RwInt32 v4, RwInt32 tag));
extern RwMatrix4d *         RwQueryRotateMatrix ARGS((RwMatrix4d *mat,
                                       RwV3d *axis, RwReal *degrees));
extern RwInt32              RwRandom ARGS((void));
extern RwRaster *           RwReadMaskRaster ARGS((char *name));
extern RwTexture *          RwReadNamedTexture ARGS((char *name));
extern RwRaster *           RwReadRaster ARGS((char *name,
                                   RwRasterOptions options));
extern RwClump *            RwReadShape ARGS((char *filename));
extern RwTexture *          RwReadTexture ARGS((char *name));
extern RwRaster *           RwReleaseRasterPixels ARGS((RwRaster *raster, unsigned char *pixels));
extern RwClump *            RwRemoveChildFromClump ARGS((RwClump *clump));
extern RwClump *            RwRemoveClumpFromScene ARGS((RwClump *clump));
extern RwBool               RwRemoveHint ARGS((RwClumpHints hint));
extern RwClump *            RwRemoveHintFromClump ARGS((RwClump *clump,
                                   RwClumpHints hint));
extern RwLight *            RwRemoveLightFromScene ARGS((RwLight *light));
extern RwMaterial *         RwRemoveTextureModeFromMaterial ARGS((RwMaterial *m,
                                   RwTextureModes mode));
extern RwPolygon3d *        RwRemoveTextureModeFromPolygon ARGS((RwPolygon3d *pol,
                                   RwTextureModes mode));
extern RwBool               RwRemoveTextureModeFromSurface ARGS((RwTextureModes mode));
extern RwUserDraw *         RwRemoveUserDrawFromClump ARGS((RwUserDraw * userdraw));
extern RwClump *            RwRenderClump ARGS((RwClump *clump));
extern RwScene *            RwRenderScene ARGS((RwScene *scene));
extern RwCamera *           RwResetCamera ARGS((RwCamera *cam));
extern RwPolygon3d *        RwReversePolygonFace ARGS((RwPolygon3d *pol));
extern RwCamera *           RwRevolveCamera ARGS((RwCamera *cam, RwReal theta));
extern RwBool               RwRotateCTM ARGS((RwReal ax, RwReal ay, RwReal az,
                                   RwReal theta));
extern RwBool               RwRotateJointTM ARGS((RwReal ax,
                                   RwReal ay, RwReal az, RwReal theta));
extern RwMatrix4d *         RwRotateMatrix ARGS((RwMatrix4d *mat,
                                   RwReal vx, RwReal vy, RwReal vz,
                                   RwReal theta, RwCombineOperation op));
extern RwMatrix4d *         RwRotateMatrixCos ARGS((RwMatrix4d *mat,
                                   RwReal vx, RwReal vy, RwReal vz,
                                   RwReal ctheta, RwReal dir,
                                   RwCombineOperation op));
extern RwBool               RwScaleCTM ARGS((RwReal sx, RwReal sy, RwReal sz));
extern RwMatrix4d *         RwScaleMatrix ARGS((RwMatrix4d *mat,
                                   RwReal sx, RwReal sy, RwReal sz,
                                   RwCombineOperation op));
extern RwV3d *              RwScaleVector ARGS((RwV3d *a, RwReal scale,
                                   RwV3d *c));
extern RwMatrix4d *         RwScratchMatrix ARGS((void));
extern RwCamera *           RwSetCameraBackColor ARGS((RwCamera *cam,
                                   RwReal r, RwReal g, RwReal b));
extern RwCamera *           RwSetCameraBackColorStruct ARGS((RwCamera *cam,
                                   RwRGBColor *color));
extern RwCamera *           RwSetCameraBackdrop ARGS((RwCamera *cam,
                                   RwRaster *ras));
extern RwCamera *           RwSetCameraBackdropOffset ARGS((RwCamera *cam,
                                   RwInt32 x, RwInt32 y));
extern RwCamera *           RwSetCameraBackdropViewportRect ARGS((RwCamera *cam,
                                   RwInt32 x, RwInt32 y, RwInt32 w, RwInt32 h));

extern RwCamera *           RwSetCameraData ARGS((RwCamera *cam,
                                   void *data));
extern RwCamera *           RwSetCameraLookAt ARGS((RwCamera *cam,
                                   RwReal x, RwReal y, RwReal z));
extern RwCamera *           RwSetCameraLookUp ARGS((RwCamera *cam,
                                   RwReal x, RwReal y, RwReal z));
extern RwCamera *           RwSetCameraNearClipping ARGS((RwCamera *cam,
                                   RwReal neard));
extern RwCamera *           RwSetCameraFarClipping ARGS((RwCamera *cam,
                                   RwReal fard));
extern RwCamera *           RwSetCameraPosition ARGS((RwCamera *cam,
                                   RwReal x, RwReal y, RwReal z));
extern RwCamera *           RwSetCameraProjection ARGS((RwCamera *cam,
                                   RwCameraProjection kind));
extern RwCamera *           RwSetCameraViewOffset ARGS((RwCamera *cam,
                                   RwReal x, RwReal y));
extern RwCamera *           RwSetCameraViewport ARGS((RwCamera *cam,
                                   RwInt32 x, RwInt32 y, RwInt32 w, RwInt32 h));
extern RwCamera *           RwSetCameraViewwindow ARGS((RwCamera *cam,
                                   RwReal w, RwReal h));
extern RwClump *            RwSetClumpData ARGS((RwClump *clump,
                                   void *data));
extern RwClump *            RwSetClumpAxisAlignment ARGS((RwClump *clump,
                                   RwAxisAlignment alignment));
extern RwClump *            RwSetClumpHints ARGS((RwClump *clump,
                                   RwClumpHints hints));
extern RwClump *            RwSetClumpState ARGS((RwClump *clump,
                                   RwState onoff));
extern RwClump *            RwSetClumpTag ARGS((RwClump *clump, RwInt32 tag));
extern RwClump *            RwSetClumpVertex ARGS((RwClump *clump,
                                   RwInt32 index, RwV3d *vertex));
extern RwClump *            RwSetClumpVertexNormal ARGS((RwClump *clump,
                                   RwInt32 vindex, RwV3d *normal));
extern RwClump *            RwSetClumpVertexUV ARGS((RwClump *clump,
                                   RwInt32 index, RwReal u, RwReal v));
extern RwClump *            RwSetClumpVertices ARGS((RwClump *clump,
                                   RwInt32 *index, RwV3d *vertex, RwInt32 n));
extern void                 RwSetDebugAssertionState ARGS((RwState state));
extern void                 RwSetDebugMessageState ARGS((RwState state));
extern void                 RwSetDebugOutputState ARGS((RwState state));
extern void                 RwSetDebugScriptState ARGS((RwState state));
extern void                 RwSetDebugSeverity ARGS((RwDebugSeverity severity));
extern RwBool               RwSetDebugStream ARGS((FILE * stream));
extern void                 RwSetDebugTraceState ARGS((RwState state));
extern RwBool               RwSetAxisAlignment ARGS((RwAxisAlignment alignment));
extern RwBool               RwSetHints ARGS((RwClumpHints hints));
extern RwLight *            RwSetLightBrightness ARGS((RwLight *light,
                                   RwReal lum));
extern RwLight *            RwSetLightColor ARGS((RwLight *light, 
                                    RwReal r,RwReal g,RwReal b));
extern RwLight *            RwSetLightColorStruct ARGS((RwLight *light, 
                                    RwRGBColor *color));
extern RwLight *            RwSetLightConeAngle ARGS((RwLight *light,
                                   RwReal theta));
extern RwLight *            RwSetLightData ARGS((RwLight *light,
                                   void *data));
extern RwLight *            RwSetLightPosition ARGS((RwLight *light,
                                   RwReal x, RwReal y, RwReal z));
extern RwLight *            RwSetLightState ARGS((RwLight *light,
                                   RwState state));
extern RwLight *            RwSetLightVector ARGS((RwLight *light,
                                   RwReal x, RwReal y, RwReal z));
extern RwMaterial *         RwSetMaterialAmbient ARGS((RwMaterial *m,
                                   RwReal ka));
extern RwMaterial *         RwSetMaterialColor ARGS((RwMaterial *m,
                                   RwReal r, RwReal g, RwReal b));
extern RwMaterial *         RwSetMaterialColorStruct ARGS((RwMaterial *m,
                                   RwRGBColor *color));
extern RwMaterial *         RwSetMaterialData ARGS((RwMaterial *m,
                                   void *data));
extern RwMaterial *         RwSetMaterialDiffuse ARGS((RwMaterial *m,
                                   RwReal kd));
extern RwMaterial *         RwSetMaterialGeometrySampling ARGS((RwMaterial *m,
                                   RwGeometrySampling t));
extern RwMaterial *         RwSetMaterialLightSampling ARGS((RwMaterial *m,
                                   RwLightSampling t));
extern RwMaterial *         RwSetMaterialOpacity ARGS((RwMaterial *m,
                                   RwReal opacity));
extern RwMaterial *         RwSetMaterialSpecular ARGS((RwMaterial *m,
                                   RwReal ks));
extern RwMaterial *         RwSetMaterialSurface ARGS((RwMaterial *m,
                                   RwReal ka, RwReal kd, RwReal ks));
extern RwMaterial *         RwSetMaterialTexture ARGS((RwMaterial *m,
                                   RwTexture *what));
extern RwMaterial *         RwSetMaterialTextureModes ARGS((RwMaterial *m,
                                   RwTextureModes modes));
extern RwMatrix4d *         RwSetMatrixElement ARGS((RwMatrix4d *mat,
                                   RwInt32 i, RwInt32 j, RwReal val));
extern RwMatrix4d *         RwSetMatrixElements ARGS((RwMatrix4d *mat,
                                   RwReal farray[4][4]));
extern RwInt32              RwSetPaletteEntries ARGS((RwInt32 n, RwInt32 length, RwPaletteEntry *rgb, RwPaletteOptions options));
extern RwPolygon3d *        RwSetPolygonAmbient ARGS((RwPolygon3d *pol,
                                   RwReal Ka));
extern RwPolygon3d *        RwSetPolygonColor ARGS((RwPolygon3d *pol,
                                   RwReal r, RwReal g, RwReal b));
extern RwPolygon3d *        RwSetPolygonColorStruct ARGS((RwPolygon3d *pol,
                                   RwRGBColor *color));
extern RwPolygon3d *        RwSetPolygonData ARGS((RwPolygon3d *pol,
                                   void *data));
extern RwPolygon3d *        RwSetPolygonDiffuse ARGS((RwPolygon3d *pol,
                                   RwReal Kd));
extern RwPolygon3d *        RwSetPolygonGeometrySampling ARGS((RwPolygon3d *p,
                                   RwGeometrySampling t));
extern RwPolygon3d *        RwSetPolygonLightSampling ARGS((RwPolygon3d *p,
                                   RwLightSampling t));
extern RwPolygon3d *        RwSetPolygonMaterial ARGS((RwPolygon3d *p,
                                   RwMaterial *m));
extern RwPolygon3d *        RwSetPolygonOpacity ARGS((RwPolygon3d *p,
                                   RwReal opacity));
extern RwPolygon3d *        RwSetPolygonSpecular ARGS((RwPolygon3d *pol,
                                   RwReal Ks));
extern RwPolygon3d *        RwSetPolygonSurface ARGS((RwPolygon3d *pol,
                                   RwReal ka, RwReal kd, RwReal ks));
extern RwPolygon3d *        RwSetPolygonTag ARGS((RwPolygon3d *p,
                                   RwInt32 tag));
extern RwPolygon3d *        RwSetPolygonTexture ARGS((RwPolygon3d *p,
                                   RwTexture *t));
extern RwPolygon3d *        RwSetPolygonTextureModes ARGS((RwPolygon3d *p,
                                   RwTextureModes modes));
extern RwPolygon3d *        RwSetPolygonUV ARGS((RwPolygon3d *p, RwUV *uvs));
extern RwRaster *           RwSetRasterData ARGS((RwRaster *ras, void *data));
extern RwScene *            RwSetSceneData ARGS((RwScene *scene, void *data));
extern RwBool               RwSetShapePath ARGS((char *path,
                                   RwCombineOperation op));
extern RwSpline *           RwSetSplineData ARGS((RwSpline *spline,
                                   void *user));
extern RwSpline *           RwSetSplinePoint ARGS((RwSpline *sp,
                                   RwInt32 index, RwV3d *point));
extern RwBool               RwSetSurface ARGS((RwReal ka,
                                   RwReal kd, RwReal ks));
extern RwBool               RwSetSurfaceAmbient ARGS((RwReal ka));
extern RwBool               RwSetSurfaceColor ARGS((RwReal r,
                                   RwReal g, RwReal b));
extern RwBool               RwSetSurfaceDiffuse ARGS((RwReal kd));
extern RwBool               RwSetSurfaceGeometrySampling ARGS((RwGeometrySampling sampling));
extern RwBool               RwSetSurfaceLightSampling ARGS((RwLightSampling sampling));
extern RwBool               RwSetSurfaceOpacity ARGS((RwReal opacity));
extern RwBool               RwSetSurfaceSpecular ARGS((RwReal ks));
extern RwBool               RwSetSurfaceTexture ARGS((char *name));
extern RwBool               RwSetSurfaceTextureExt ARGS((char *texturename,
                                   char *maskname));
extern RwBool               RwSetSurfaceTextureModes ARGS((RwTextureModes modes));
extern RwBool               RwSetTag ARGS((RwInt32 tag));
extern RwTexture *          RwSetTextureData ARGS((RwTexture *texture,
                                   void *data));
extern RwBool               RwSetTextureDictSearchMode ARGS((RwSearchMode mode));
extern RwBool               RwSetTextureDithering ARGS((RwTextureDitherMode mode));
extern RwTexture *          RwSetTextureFrame ARGS((RwTexture *t, RwInt32 index));
extern RwTexture *          RwSetTextureFrameStep ARGS((RwTexture *t,
                                   RwInt32 val));
extern RwBool               RwSetTextureGammaCorrection ARGS((RwState state));
extern RwTexture *          RwSetTextureRaster ARGS((RwTexture *texture,
                                   RwRaster *ras));
extern RwUserDraw *         RwSetUserDrawAlignment ARGS((RwUserDraw * userdraw,
                                   RwUserDrawAlignmentTypes align));
extern RwUserDraw *         RwSetUserDrawCallback ARGS((RwUserDraw * userdraw,
                                   RwUserDrawCallBack * callback));
extern RwUserDraw *         RwSetUserDrawData ARGS((RwUserDraw * userdraw,
                                   void *data));
extern RwUserDraw *         RwSetUserDrawOffset ARGS((RwUserDraw * userdraw,
                                   RwInt32 x, RwInt32 y));
extern RwUserDraw *         RwSetUserDrawParentAlignment ARGS((RwUserDraw * userdraw,
                                   RwUserDrawAlignmentTypes align));
extern RwUserDraw *         RwSetUserDrawSize ARGS((RwUserDraw * userdraw,
                                   RwInt32 width, RwInt32 height));
extern RwUserDraw *         RwSetUserDrawType ARGS((RwUserDraw * userdraw,
                                   RwUserDrawType type));
extern RwUserDraw *         RwSetUserDrawVertexIndex ARGS((RwUserDraw * userdraw,
                                   RwInt32 index));
extern RwCamera *           RwShowCameraImage ARGS((RwCamera *cam,
                                   void *param));
extern RwBool               RwSphere ARGS((RwReal radius,
                                   RwInt32 sides));
extern RwClump *            RwSphericalTexturizeClump ARGS((RwClump *clump));
extern RwV3d *              RwSplinePoint ARGS((RwSpline *spline,
                                   RwSplinePath path, RwReal where,
                                   RwV3d *pt, RwV3d *vec));
extern RwReal               RwSplineTransform ARGS((RwSpline *sp,
                                   RwSplinePath path, RwReal where,
                                   RwV3d *up, RwMatrix4d *mat));
extern void                 RwSRandom ARGS((RwUInt32 x));
extern RwV3d *              RwSubtractVector ARGS((RwV3d *a,
                                   RwV3d *b, RwV3d *c));
extern RwBool               RwTextureDictBegin ARGS((void));
extern RwBool               RwTextureDictEnd ARGS((void));
extern RwTexture *          RwTextureNextFrame ARGS((RwTexture *t));
extern RwCamera *           RwTiltCamera ARGS((RwCamera *cam,
                                   RwReal theta));
extern RwBool               RwTransformBegin ARGS((void));
extern RwBool               RwTransformCTM ARGS((RwMatrix4d *mat));
extern RwMatrix4d *         RwGetLightLTM ARGS((RwLight * light,
						RwMatrix4d * m));
extern RwLight *            RwTransformLight ARGS((RwLight * light, 
						   RwMatrix4d * m, 
						   RwCombineOperation op));
extern RwMatrix4d *         RwGetCameraLTM ARGS((RwCamera * camera,
						 RwMatrix4d * m));
extern RwCamera *           RwTransformCameraOrientation ARGS((RwCamera * c, 
							      RwMatrix4d * m));
extern RwCamera *           RwTransformCamera ARGS((RwCamera * camera, 
						    RwMatrix4d * m, 
						    RwCombineOperation op));
extern RwClump *            RwTransformClump ARGS((RwClump *clump,
                                   RwMatrix4d *mat, RwCombineOperation op));
extern RwClump *            RwTransformClumpJoint ARGS((RwClump *clump,
                                   RwMatrix4d *mat, RwCombineOperation op));
extern RwBool               RwTransformEnd ARGS((void));
extern RwBool               RwTransformJointTM ARGS((RwMatrix4d *mat));
extern RwMatrix4d *         RwTransformMatrix ARGS((RwMatrix4d *m,
                                   RwMatrix4d *mat,
                                   RwCombineOperation op));
extern RwV3d *              RwTransformPoint ARGS((RwV3d *a,
                                   RwMatrix4d *mat));
extern RwV3d *              RwTransformVector ARGS((RwV3d *a,
                                   RwMatrix4d *mat));
extern RwBool               RwTranslateCTM ARGS((RwReal tx,
                                   RwReal ty, RwReal tz));
extern RwMatrix4d *         RwTranslateMatrix ARGS((RwMatrix4d *mat,
                                   RwReal tx, RwReal ty, RwReal tz,
                                   RwCombineOperation op));
extern RwBool               RwTriangle ARGS((RwInt32 v1, RwInt32 v2, RwInt32 v3));
extern RwBool               RwTriangleExt ARGS((RwInt32 v1, RwInt32 v2, RwInt32 v3,
                                   RwInt32 tag));
extern RwCamera *           RwUndamageCameraViewport ARGS((RwCamera *cam,
                                   RwInt32 x, RwInt32 y, RwInt32 w, RwInt32 h));
extern RwCamera *           RwVCMoveCamera ARGS((RwCamera *cam,
                                   RwReal x, RwReal y, RwReal z));
extern RwInt32              RwVertex ARGS((RwReal x, RwReal y, RwReal z));
extern RwInt32              RwVertexExt ARGS((RwReal x, RwReal y, RwReal z,
                                   RwUV *uv, RwV3d *normal));
extern RwCamera *           RwWCMoveCamera ARGS((RwCamera *cam,
                                   RwReal x, RwReal y, RwReal z));
extern RwBool               RwWriteShape ARGS((char *filename,
                                   RwClump *clump));

#ifdef    __cplusplus
}
#endif /* __cplusplus */

#endif /* _RWLIBH */
